Subject: Re: bug#31339: 25.3.50; package-list-packages does not provide useful error when gnutls-cli is missing

From: Eli Zaretskii <[email-masked]>
Date: Wed, 02 May 2018 17:52:03 +0300

> From: Eric Hanchrow <[email-masked]>
> Date: Wed, 02 May 2018 02:33:39 +0000
> 
> I typed "M-x package-list-packages", and saw complaints about ...
> 
> Opening TLS connection to ‘melpa.org’...
> Opening TLS connection with ‘gnutls-cli --x509cafile
> /etc/pki/tls/certs/ca-bundle.crt -p 443 melpa.org’...failed
> Opening TLS connection with ‘gnutls-cli --x509cafile
> /etc/pki/tls/certs/ca-bundle.crt -p 443 melpa.org --protocols ssl3’...failed
> Opening TLS connection with ‘openssl s_client -connect melpa.org:443
> -CAfile /etc/pki/tls/certs/ca-bundle.crt -no_ssl2 -ign_eof’...failed
> Opening TLS connection to ‘melpa.org’...failed
> Package refresh done
> Failed to download ‘melpa’ archive.
> 
> I eventually realized that the problem was simply due to my not having a
> gnutls-cli executable!  But it took me longer to realize that than it
> should have.  OK, I confess; it took me _two years_ to realize that
> (seriously).  I'd just assumed that the problem was some subtle certificate
> mismatch or something that I'd never understand, and I put up with it.
> 
> Would it be possible to emit a message describing _why_ gnutls-cli failed?

Actually, we deprecated tls.el and gnutls-cli, and we now ask users to
build Emacs with the GnuTLS library, which enables these features
internally.  I don't think investing efforts in improving a deprecated
feature would be a good investment of our resources.

Thanks.